import { contentHoldNode, nodeSet } from '@/configs/node.config'
import {
    chooseRowRef,
    compareContainerRef,
    compareData,
    compareLeftContent,
    compareLeftRef,
    compareRightContent,
    compareRightRef,
    showCompare
} from '../constants/compare'

export const handleClickDom = (event: any) => {
    if (!showCompare.value) return
    const element = event.target
    const container = compareContainerRef.value
    const elementRect = element.getBoundingClientRect()
    const containerRect = container.getBoundingClientRect()
    const distance = elementRect.top - containerRect.top
    chooseRowRef.value.style.top = distance + 'px'
    chooseRowRef.value.style.height = event.target.offsetHeight + 'px'
}
export const handleScrollTopLeft = (event: Event) => {
    const scrollTop = (event.target as HTMLInputElement).scrollTop
    compareRightRef.value?.handleScrollTop(scrollTop)
    chooseRowRef.value.style.height = '0px'
}
export const handleScrollTopRight = (event: Event) => {
    const scrollTop = (event.target as HTMLInputElement).scrollTop
    compareLeftRef.value?.handleScrollTop(scrollTop)
    chooseRowRef.value.style.height = '0px'
}
export const uploadLeftXml = async () => {
    const input = document.createElement('input')
    input.type = 'file'
    input.accept = 'application/xml,text/xml'
    input.multiple = false
    input.click()
    input.addEventListener('change', async (event: Event) => {
        const files = (event.target as HTMLInputElement).files
        if (files && files.length > 0) {
            const file = files[0]
            const xmlProcessing = useXMLProcessing()
            const res = await xmlProcessing.processFile(file, nodeSet, contentHoldNode)
            compareLeftContent.value = res.xmlContent
            compareData.treeOld = res.xmlContent
        }
        input.remove()
    })
}
export const uploadRightXml = async () => {
    const input = document.createElement('input')
    input.type = 'file'
    input.accept = 'application/xml,text/xml'
    input.multiple = false
    input.click()
    input.addEventListener('change', async (event: Event) => {
        const files = (event.target as HTMLInputElement).files
        if (files && files.length > 0) {
            const file = files[0]
            const xmlProcessing = useXMLProcessing()
            const res = await xmlProcessing.processFile(file, nodeSet, contentHoldNode)
            compareRightContent.value = res.xmlContent
            compareData.treeNew = res.xmlContent
        }
        input.remove()
    })
}
export const clearLeftXml = () => {
    compareData.treeNew = compareRightContent.value
    compareLeftContent.value = ''
    compareData.treeOld = ''
}
export const clearRightXml = () => {
    compareData.treeOld = compareLeftContent.value
    compareRightContent.value = ''
    compareData.treeNew = ''
}
